<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FyzickaOsoba StructType
 * @subpackage Structs
 */
class FyzickaOsoba extends Osoba
{
    /**
     * The Meno
     * @var string
     */
    public $Meno;
    /**
     * The Priezvisko
     * @var string
     */
    public $Priezvisko;
    /**
     * The TitulPredMenom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TitulPredMenom;
    /**
     * The TitulZaMenom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TitulZaMenom;
    /**
     * The RodneCislo
     * @var string
     */
    public $RodneCislo;
    /**
     * The DatumNarodenia
     * @var string
     */
    public $DatumNarodenia;
    /**
     * The StatneObcianstvo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $StatneObcianstvo;
    /**
     * Constructor method for FyzickaOsoba
     * @uses FyzickaOsoba::setMeno()
     * @uses FyzickaOsoba::setPriezvisko()
     * @uses FyzickaOsoba::setTitulPredMenom()
     * @uses FyzickaOsoba::setTitulZaMenom()
     * @uses FyzickaOsoba::setRodneCislo()
     * @uses FyzickaOsoba::setDatumNarodenia()
     * @uses FyzickaOsoba::setStatneObcianstvo()
     * @param string $meno
     * @param string $priezvisko
     * @param string $titulPredMenom
     * @param string $titulZaMenom
     * @param string $rodneCislo
     * @param string $datumNarodenia
     * @param string $statneObcianstvo
     */
    public function __construct($meno = null, $priezvisko = null, $titulPredMenom = null, $titulZaMenom = null, $rodneCislo = null, $datumNarodenia = null, $statneObcianstvo = null)
    {
        $this
            ->setMeno($meno)
            ->setPriezvisko($priezvisko)
            ->setTitulPredMenom($titulPredMenom)
            ->setTitulZaMenom($titulZaMenom)
            ->setRodneCislo($rodneCislo)
            ->setDatumNarodenia($datumNarodenia)
            ->setStatneObcianstvo($statneObcianstvo);
    }
    /**
     * Get Meno value
     * @return string|null
     */
    public function getMeno()
    {
        return $this->Meno;
    }
    /**
     * Set Meno value
     * @param string $meno
     * @return \StructType\FyzickaOsoba
     */
    public function setMeno($meno = null)
    {
        // validation for constraint: string
        if (!is_null($meno) && !is_string($meno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($meno, true), gettype($meno)), __LINE__);
        }
        $this->Meno = $meno;
        return $this;
    }
    /**
     * Get Priezvisko value
     * @return string|null
     */
    public function getPriezvisko()
    {
        return $this->Priezvisko;
    }
    /**
     * Set Priezvisko value
     * @param string $priezvisko
     * @return \StructType\FyzickaOsoba
     */
    public function setPriezvisko($priezvisko = null)
    {
        // validation for constraint: string
        if (!is_null($priezvisko) && !is_string($priezvisko)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priezvisko, true), gettype($priezvisko)), __LINE__);
        }
        $this->Priezvisko = $priezvisko;
        return $this;
    }
    /**
     * Get TitulPredMenom value
     * @return string|null
     */
    public function getTitulPredMenom()
    {
        return $this->TitulPredMenom;
    }
    /**
     * Set TitulPredMenom value
     * @param string $titulPredMenom
     * @return \StructType\FyzickaOsoba
     */
    public function setTitulPredMenom($titulPredMenom = null)
    {
        // validation for constraint: string
        if (!is_null($titulPredMenom) && !is_string($titulPredMenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titulPredMenom, true), gettype($titulPredMenom)), __LINE__);
        }
        $this->TitulPredMenom = $titulPredMenom;
        return $this;
    }
    /**
     * Get TitulZaMenom value
     * @return string|null
     */
    public function getTitulZaMenom()
    {
        return $this->TitulZaMenom;
    }
    /**
     * Set TitulZaMenom value
     * @param string $titulZaMenom
     * @return \StructType\FyzickaOsoba
     */
    public function setTitulZaMenom($titulZaMenom = null)
    {
        // validation for constraint: string
        if (!is_null($titulZaMenom) && !is_string($titulZaMenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titulZaMenom, true), gettype($titulZaMenom)), __LINE__);
        }
        $this->TitulZaMenom = $titulZaMenom;
        return $this;
    }
    /**
     * Get RodneCislo value
     * @return string|null
     */
    public function getRodneCislo()
    {
        return $this->RodneCislo;
    }
    /**
     * Set RodneCislo value
     * @param string $rodneCislo
     * @return \StructType\FyzickaOsoba
     */
    public function setRodneCislo($rodneCislo = null)
    {
        // validation for constraint: string
        if (!is_null($rodneCislo) && !is_string($rodneCislo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rodneCislo, true), gettype($rodneCislo)), __LINE__);
        }
        $this->RodneCislo = $rodneCislo;
        return $this;
    }
    /**
     * Get DatumNarodenia value
     * @return string|null
     */
    public function getDatumNarodenia()
    {
        return $this->DatumNarodenia;
    }
    /**
     * Set DatumNarodenia value
     * @param string $datumNarodenia
     * @return \StructType\FyzickaOsoba
     */
    public function setDatumNarodenia($datumNarodenia = null)
    {
        // validation for constraint: string
        if (!is_null($datumNarodenia) && !is_string($datumNarodenia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($datumNarodenia, true), gettype($datumNarodenia)), __LINE__);
        }
        $this->DatumNarodenia = $datumNarodenia;
        return $this;
    }
    /**
     * Get StatneObcianstvo value
     * @return string|null
     */
    public function getStatneObcianstvo()
    {
        return $this->StatneObcianstvo;
    }
    /**
     * Set StatneObcianstvo value
     * @param string $statneObcianstvo
     * @return \StructType\FyzickaOsoba
     */
    public function setStatneObcianstvo($statneObcianstvo = null)
    {
        // validation for constraint: string
        if (!is_null($statneObcianstvo) && !is_string($statneObcianstvo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statneObcianstvo, true), gettype($statneObcianstvo)), __LINE__);
        }
        $this->StatneObcianstvo = $statneObcianstvo;
        return $this;
    }
}
