<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FyzickaOsobaPodnikatel StructType
 * @subpackage Structs
 */
class FyzickaOsobaPodnikatel extends Osoba
{
    /**
     * The ObchodneMeno
     * @var string
     */
    public $ObchodneMeno;
    /**
     * The Meno
     * @var string
     */
    public $Meno;
    /**
     * The Priezvisko
     * @var string
     */
    public $Priezvisko;
    /**
     * The TitulPredMenom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TitulPredMenom;
    /**
     * The TitulZaMenom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TitulZaMenom;
    /**
     * The Ico
     * @var string
     */
    public $Ico;
    /**
     * The Register
     * @var string
     */
    public $Register;
    /**
     * The CisloRegistracie
     * @var string
     */
    public $CisloRegistracie;
    /**
     * Constructor method for FyzickaOsobaPodnikatel
     * @uses FyzickaOsobaPodnikatel::setObchodneMeno()
     * @uses FyzickaOsobaPodnikatel::setMeno()
     * @uses FyzickaOsobaPodnikatel::setPriezvisko()
     * @uses FyzickaOsobaPodnikatel::setTitulPredMenom()
     * @uses FyzickaOsobaPodnikatel::setTitulZaMenom()
     * @uses FyzickaOsobaPodnikatel::setIco()
     * @uses FyzickaOsobaPodnikatel::setRegister()
     * @uses FyzickaOsobaPodnikatel::setCisloRegistracie()
     * @param string $obchodneMeno
     * @param string $meno
     * @param string $priezvisko
     * @param string $titulPredMenom
     * @param string $titulZaMenom
     * @param string $ico
     * @param string $register
     * @param string $cisloRegistracie
     */
    public function __construct($obchodneMeno = null, $meno = null, $priezvisko = null, $titulPredMenom = null, $titulZaMenom = null, $ico = null, $register = null, $cisloRegistracie = null)
    {
        $this
            ->setObchodneMeno($obchodneMeno)
            ->setMeno($meno)
            ->setPriezvisko($priezvisko)
            ->setTitulPredMenom($titulPredMenom)
            ->setTitulZaMenom($titulZaMenom)
            ->setIco($ico)
            ->setRegister($register)
            ->setCisloRegistracie($cisloRegistracie);
    }
    /**
     * Get ObchodneMeno value
     * @return string|null
     */
    public function getObchodneMeno()
    {
        return $this->ObchodneMeno;
    }
    /**
     * Set ObchodneMeno value
     * @param string $obchodneMeno
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setObchodneMeno($obchodneMeno = null)
    {
        // validation for constraint: string
        if (!is_null($obchodneMeno) && !is_string($obchodneMeno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($obchodneMeno, true), gettype($obchodneMeno)), __LINE__);
        }
        $this->ObchodneMeno = $obchodneMeno;
        return $this;
    }
    /**
     * Get Meno value
     * @return string|null
     */
    public function getMeno()
    {
        return $this->Meno;
    }
    /**
     * Set Meno value
     * @param string $meno
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setMeno($meno = null)
    {
        // validation for constraint: string
        if (!is_null($meno) && !is_string($meno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($meno, true), gettype($meno)), __LINE__);
        }
        $this->Meno = $meno;
        return $this;
    }
    /**
     * Get Priezvisko value
     * @return string|null
     */
    public function getPriezvisko()
    {
        return $this->Priezvisko;
    }
    /**
     * Set Priezvisko value
     * @param string $priezvisko
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setPriezvisko($priezvisko = null)
    {
        // validation for constraint: string
        if (!is_null($priezvisko) && !is_string($priezvisko)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priezvisko, true), gettype($priezvisko)), __LINE__);
        }
        $this->Priezvisko = $priezvisko;
        return $this;
    }
    /**
     * Get TitulPredMenom value
     * @return string|null
     */
    public function getTitulPredMenom()
    {
        return $this->TitulPredMenom;
    }
    /**
     * Set TitulPredMenom value
     * @param string $titulPredMenom
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setTitulPredMenom($titulPredMenom = null)
    {
        // validation for constraint: string
        if (!is_null($titulPredMenom) && !is_string($titulPredMenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titulPredMenom, true), gettype($titulPredMenom)), __LINE__);
        }
        $this->TitulPredMenom = $titulPredMenom;
        return $this;
    }
    /**
     * Get TitulZaMenom value
     * @return string|null
     */
    public function getTitulZaMenom()
    {
        return $this->TitulZaMenom;
    }
    /**
     * Set TitulZaMenom value
     * @param string $titulZaMenom
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setTitulZaMenom($titulZaMenom = null)
    {
        // validation for constraint: string
        if (!is_null($titulZaMenom) && !is_string($titulZaMenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titulZaMenom, true), gettype($titulZaMenom)), __LINE__);
        }
        $this->TitulZaMenom = $titulZaMenom;
        return $this;
    }
    /**
     * Get Ico value
     * @return string|null
     */
    public function getIco()
    {
        return $this->Ico;
    }
    /**
     * Set Ico value
     * @param string $ico
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setIco($ico = null)
    {
        // validation for constraint: string
        if (!is_null($ico) && !is_string($ico)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ico, true), gettype($ico)), __LINE__);
        }
        $this->Ico = $ico;
        return $this;
    }
    /**
     * Get Register value
     * @return string|null
     */
    public function getRegister()
    {
        return $this->Register;
    }
    /**
     * Set Register value
     * @param string $register
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setRegister($register = null)
    {
        // validation for constraint: string
        if (!is_null($register) && !is_string($register)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($register, true), gettype($register)), __LINE__);
        }
        $this->Register = $register;
        return $this;
    }
    /**
     * Get CisloRegistracie value
     * @return string|null
     */
    public function getCisloRegistracie()
    {
        return $this->CisloRegistracie;
    }
    /**
     * Set CisloRegistracie value
     * @param string $cisloRegistracie
     * @return \StructType\FyzickaOsobaPodnikatel
     */
    public function setCisloRegistracie($cisloRegistracie = null)
    {
        // validation for constraint: string
        if (!is_null($cisloRegistracie) && !is_string($cisloRegistracie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cisloRegistracie, true), gettype($cisloRegistracie)), __LINE__);
        }
        $this->CisloRegistracie = $cisloRegistracie;
        return $this;
    }
}
