<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getZoznamSudovResponse StructType
 * @subpackage Structs
 */
class GetZoznamSudovResponse extends AbstractStructBase
{
    /**
     * The Sud
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Sud[]
     */
    public $Sud;
    /**
     * Constructor method for getZoznamSudovResponse
     * @uses GetZoznamSudovResponse::setSud()
     * @param \StructType\Sud[] $sud
     */
    public function __construct(array $sud = array())
    {
        $this
            ->setSud($sud);
    }
    /**
     * Get Sud value
     * @return \StructType\Sud[]|null
     */
    public function getSud()
    {
        return $this->Sud;
    }
    /**
     * This method is responsible for validating the values passed to the setSud method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSud method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSudForArrayConstraintsFromSetSud(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getZoznamSudovResponseSudItem) {
            // validation for constraint: itemType
            if (!$getZoznamSudovResponseSudItem instanceof \StructType\Sud) {
                $invalidValues[] = is_object($getZoznamSudovResponseSudItem) ? get_class($getZoznamSudovResponseSudItem) : sprintf('%s(%s)', gettype($getZoznamSudovResponseSudItem), var_export($getZoznamSudovResponseSudItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Sud property can only contain items of type \StructType\Sud, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Sud value
     * @throws \InvalidArgumentException
     * @param \StructType\Sud[] $sud
     * @return \StructType\GetZoznamSudovResponse
     */
    public function setSud(array $sud = array())
    {
        // validation for constraint: array
        if ('' !== ($sudArrayErrorMessage = self::validateSudForArrayConstraintsFromSetSud($sud))) {
            throw new \InvalidArgumentException($sudArrayErrorMessage, __LINE__);
        }
        $this->Sud = $sud;
        return $this;
    }
    /**
     * Add item to Sud value
     * @throws \InvalidArgumentException
     * @param \StructType\Sud $item
     * @return \StructType\GetZoznamSudovResponse
     */
    public function addToSud(\StructType\Sud $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Sud) {
            throw new \InvalidArgumentException(sprintf('The Sud property can only contain items of type \StructType\Sud, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Sud[] = $item;
        return $this;
    }
}
