<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KonanieInfoList StructType
 * @subpackage Structs
 */
class KonanieInfoList extends AbstractStructBase
{
    /**
     * The KonanieInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\KonanieInfo[]
     */
    public $KonanieInfo;
    /**
     * Constructor method for KonanieInfoList
     * @uses KonanieInfoList::setKonanieInfo()
     * @param \StructType\KonanieInfo[] $konanieInfo
     */
    public function __construct(array $konanieInfo = array())
    {
        $this
            ->setKonanieInfo($konanieInfo);
    }
    /**
     * Get KonanieInfo value
     * @return \StructType\KonanieInfo[]|null
     */
    public function getKonanieInfo()
    {
        return $this->KonanieInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setKonanieInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKonanieInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKonanieInfoForArrayConstraintsFromSetKonanieInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $konanieInfoListKonanieInfoItem) {
            // validation for constraint: itemType
            if (!$konanieInfoListKonanieInfoItem instanceof \StructType\KonanieInfo) {
                $invalidValues[] = is_object($konanieInfoListKonanieInfoItem) ? get_class($konanieInfoListKonanieInfoItem) : sprintf('%s(%s)', gettype($konanieInfoListKonanieInfoItem), var_export($konanieInfoListKonanieInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KonanieInfo property can only contain items of type \StructType\KonanieInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KonanieInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\KonanieInfo[] $konanieInfo
     * @return \StructType\KonanieInfoList
     */
    public function setKonanieInfo(array $konanieInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($konanieInfoArrayErrorMessage = self::validateKonanieInfoForArrayConstraintsFromSetKonanieInfo($konanieInfo))) {
            throw new \InvalidArgumentException($konanieInfoArrayErrorMessage, __LINE__);
        }
        $this->KonanieInfo = $konanieInfo;
        return $this;
    }
    /**
     * Add item to KonanieInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\KonanieInfo $item
     * @return \StructType\KonanieInfoList
     */
    public function addToKonanieInfo(\StructType\KonanieInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KonanieInfo) {
            throw new \InvalidArgumentException(sprintf('The KonanieInfo property can only contain items of type \StructType\KonanieInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KonanieInfo[] = $item;
        return $this;
    }
}
