<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Spravca StructType
 * @subpackage Structs
 */
class Spravca extends AbstractStructBase
{
    /**
     * The Znacka
     * @var string
     */
    public $Znacka;
    /**
     * The DatumZapisu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DatumZapisu;
    /**
     * The Meno
     * @var string
     */
    public $Meno;
    /**
     * The Priezvisko
     * @var string
     */
    public $Priezvisko;
    /**
     * The TitulPredMenom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TitulPredMenom;
    /**
     * The TitulZaMenom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TitulZaMenom;
    /**
     * The DatumNarodenia
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DatumNarodenia;
    /**
     * The ObchodneMeno
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ObchodneMeno;
    /**
     * The Ico
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Ico;
    /**
     * The Adresa
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Adresa
     */
    public $Adresa;
    /**
     * The Telefon
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Telefon;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * Constructor method for Spravca
     * @uses Spravca::setZnacka()
     * @uses Spravca::setDatumZapisu()
     * @uses Spravca::setMeno()
     * @uses Spravca::setPriezvisko()
     * @uses Spravca::setTitulPredMenom()
     * @uses Spravca::setTitulZaMenom()
     * @uses Spravca::setDatumNarodenia()
     * @uses Spravca::setObchodneMeno()
     * @uses Spravca::setIco()
     * @uses Spravca::setAdresa()
     * @uses Spravca::setTelefon()
     * @uses Spravca::setEmail()
     * @param string $znacka
     * @param string $datumZapisu
     * @param string $meno
     * @param string $priezvisko
     * @param string $titulPredMenom
     * @param string $titulZaMenom
     * @param string $datumNarodenia
     * @param string $obchodneMeno
     * @param string $ico
     * @param \StructType\Adresa $adresa
     * @param string $telefon
     * @param string $email
     */
    public function __construct($znacka = null, $datumZapisu = null, $meno = null, $priezvisko = null, $titulPredMenom = null, $titulZaMenom = null, $datumNarodenia = null, $obchodneMeno = null, $ico = null, \StructType\Adresa $adresa = null, $telefon = null, $email = null)
    {
        $this
            ->setZnacka($znacka)
            ->setDatumZapisu($datumZapisu)
            ->setMeno($meno)
            ->setPriezvisko($priezvisko)
            ->setTitulPredMenom($titulPredMenom)
            ->setTitulZaMenom($titulZaMenom)
            ->setDatumNarodenia($datumNarodenia)
            ->setObchodneMeno($obchodneMeno)
            ->setIco($ico)
            ->setAdresa($adresa)
            ->setTelefon($telefon)
            ->setEmail($email);
    }
    /**
     * Get Znacka value
     * @return string|null
     */
    public function getZnacka()
    {
        return $this->Znacka;
    }
    /**
     * Set Znacka value
     * @param string $znacka
     * @return \StructType\Spravca
     */
    public function setZnacka($znacka = null)
    {
        // validation for constraint: string
        if (!is_null($znacka) && !is_string($znacka)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($znacka, true), gettype($znacka)), __LINE__);
        }
        $this->Znacka = $znacka;
        return $this;
    }
    /**
     * Get DatumZapisu value
     * @return string|null
     */
    public function getDatumZapisu()
    {
        return $this->DatumZapisu;
    }
    /**
     * Set DatumZapisu value
     * @param string $datumZapisu
     * @return \StructType\Spravca
     */
    public function setDatumZapisu($datumZapisu = null)
    {
        // validation for constraint: string
        if (!is_null($datumZapisu) && !is_string($datumZapisu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($datumZapisu, true), gettype($datumZapisu)), __LINE__);
        }
        $this->DatumZapisu = $datumZapisu;
        return $this;
    }
    /**
     * Get Meno value
     * @return string|null
     */
    public function getMeno()
    {
        return $this->Meno;
    }
    /**
     * Set Meno value
     * @param string $meno
     * @return \StructType\Spravca
     */
    public function setMeno($meno = null)
    {
        // validation for constraint: string
        if (!is_null($meno) && !is_string($meno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($meno, true), gettype($meno)), __LINE__);
        }
        $this->Meno = $meno;
        return $this;
    }
    /**
     * Get Priezvisko value
     * @return string|null
     */
    public function getPriezvisko()
    {
        return $this->Priezvisko;
    }
    /**
     * Set Priezvisko value
     * @param string $priezvisko
     * @return \StructType\Spravca
     */
    public function setPriezvisko($priezvisko = null)
    {
        // validation for constraint: string
        if (!is_null($priezvisko) && !is_string($priezvisko)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priezvisko, true), gettype($priezvisko)), __LINE__);
        }
        $this->Priezvisko = $priezvisko;
        return $this;
    }
    /**
     * Get TitulPredMenom value
     * @return string|null
     */
    public function getTitulPredMenom()
    {
        return $this->TitulPredMenom;
    }
    /**
     * Set TitulPredMenom value
     * @param string $titulPredMenom
     * @return \StructType\Spravca
     */
    public function setTitulPredMenom($titulPredMenom = null)
    {
        // validation for constraint: string
        if (!is_null($titulPredMenom) && !is_string($titulPredMenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titulPredMenom, true), gettype($titulPredMenom)), __LINE__);
        }
        $this->TitulPredMenom = $titulPredMenom;
        return $this;
    }
    /**
     * Get TitulZaMenom value
     * @return string|null
     */
    public function getTitulZaMenom()
    {
        return $this->TitulZaMenom;
    }
    /**
     * Set TitulZaMenom value
     * @param string $titulZaMenom
     * @return \StructType\Spravca
     */
    public function setTitulZaMenom($titulZaMenom = null)
    {
        // validation for constraint: string
        if (!is_null($titulZaMenom) && !is_string($titulZaMenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titulZaMenom, true), gettype($titulZaMenom)), __LINE__);
        }
        $this->TitulZaMenom = $titulZaMenom;
        return $this;
    }
    /**
     * Get DatumNarodenia value
     * @return string|null
     */
    public function getDatumNarodenia()
    {
        return $this->DatumNarodenia;
    }
    /**
     * Set DatumNarodenia value
     * @param string $datumNarodenia
     * @return \StructType\Spravca
     */
    public function setDatumNarodenia($datumNarodenia = null)
    {
        // validation for constraint: string
        if (!is_null($datumNarodenia) && !is_string($datumNarodenia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($datumNarodenia, true), gettype($datumNarodenia)), __LINE__);
        }
        $this->DatumNarodenia = $datumNarodenia;
        return $this;
    }
    /**
     * Get ObchodneMeno value
     * @return string|null
     */
    public function getObchodneMeno()
    {
        return $this->ObchodneMeno;
    }
    /**
     * Set ObchodneMeno value
     * @param string $obchodneMeno
     * @return \StructType\Spravca
     */
    public function setObchodneMeno($obchodneMeno = null)
    {
        // validation for constraint: string
        if (!is_null($obchodneMeno) && !is_string($obchodneMeno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($obchodneMeno, true), gettype($obchodneMeno)), __LINE__);
        }
        $this->ObchodneMeno = $obchodneMeno;
        return $this;
    }
    /**
     * Get Ico value
     * @return string|null
     */
    public function getIco()
    {
        return $this->Ico;
    }
    /**
     * Set Ico value
     * @param string $ico
     * @return \StructType\Spravca
     */
    public function setIco($ico = null)
    {
        // validation for constraint: string
        if (!is_null($ico) && !is_string($ico)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ico, true), gettype($ico)), __LINE__);
        }
        $this->Ico = $ico;
        return $this;
    }
    /**
     * Get Adresa value
     * @return \StructType\Adresa|null
     */
    public function getAdresa()
    {
        return $this->Adresa;
    }
    /**
     * Set Adresa value
     * @param \StructType\Adresa $adresa
     * @return \StructType\Spravca
     */
    public function setAdresa(\StructType\Adresa $adresa = null)
    {
        $this->Adresa = $adresa;
        return $this;
    }
    /**
     * Get Telefon value
     * @return string|null
     */
    public function getTelefon()
    {
        return $this->Telefon;
    }
    /**
     * Set Telefon value
     * @param string $telefon
     * @return \StructType\Spravca
     */
    public function setTelefon($telefon = null)
    {
        // validation for constraint: string
        if (!is_null($telefon) && !is_string($telefon)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($telefon, true), gettype($telefon)), __LINE__);
        }
        $this->Telefon = $telefon;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \StructType\Spravca
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
}
